Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce_ftrans.h90	(revision 3211)
@@ -0,0 +1,58 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  dom_oce_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   dom_oce.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+
+!! DCSE_NEMO_QUESTION: Warning! See DOM/domzgr_substitute.h90
+
+!FTRANS gdep3w :I :I :z
+!FTRANS gdept :I :I :z
+!FTRANS gdepw :I :I :z
+
+!FTRANS e3v :I :I :z
+!FTRANS e3f :I :I :z
+!FTRANS e3t :I :I :z
+!FTRANS e3u :I :I :z
+!FTRANS e3w :I :I :z
+!FTRANS e3vw :I :I :z
+!FTRANS e3uw :I :I :z
+
+!FTRANS gdep3w_1 :I :I :z
+!FTRANS gdept_1 :I :I :z
+!FTRANS gdepw_1 :I :I :z
+!FTRANS e3v_1 :I :I :z
+!FTRANS e3f_1 :I :I :z
+!FTRANS e3t_1 :I :I :z
+!FTRANS e3u_1 :I :I :z
+!FTRANS e3w_1 :I :I :z
+!FTRANS e3vw_1 :I :I :z
+!FTRANS e3uw_1 :I :I :z
+!FTRANS e3t_b :I :I :z
+!FTRANS e3u_b :I :I :z
+!FTRANS e3v_b :I :I :z
+
+!FTRANS tmask :I :I :z
+!FTRANS umask :I :I :z
+!FTRANS vmask :I :I :z
+!FTRANS fmask :I :I :z
+
+!! DCSE_NEMO_QUESTION: do we need to do anything about:
+!! npcoa, nicoa, njcoa
+!! See dom_oce_alloc() in dom_oce.F90
+
+
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 3211)
@@ -41,4 +41,10 @@
    PUBLIC   dom_init   ! called by opa.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -87,4 +93,8 @@
          umask(:,:,:) = tmask(:,:,:)           ! U, V moved at T-point
          vmask(:,:,:) = tmask(:,:,:)
+#if defined key_z_first
+         umask_1(:,:) = umask(:,:,1)
+         vmask_1(:,:) = vmask(:,:,1)
+#endif
       END IF
       !
@@ -96,6 +106,11 @@
       END DO
       !                                        ! Inverse of the local depth
+#if defined key_z_first
+      hur(:,:) = 1. / ( hu(:,:) + 1.e0 - umask_1(:,:) ) * umask_1(:,:)
+      hvr(:,:) = 1. / ( hv(:,:) + 1.e0 - vmask_1(:,:) ) * vmask_1(:,:)
+#else
       hur(:,:) = 1. / ( hu(:,:) + 1.e0 - umask(:,:,1) ) * umask(:,:,1)
       hvr(:,:) = 1. / ( hv(:,:) + 1.e0 - vmask(:,:,1) ) * vmask(:,:,1)
+#endif
 
                              CALL dom_stp      ! time step
@@ -283,8 +298,15 @@
       !
       IF(lk_mpp) THEN
+#if defined key_z_first
+         CALL mpp_minloc( e1t(:,:), tmask_1(:,:), ze1min, iimi1,ijmi1 )
+         CALL mpp_minloc( e2t(:,:), tmask_1(:,:), ze2min, iimi2,ijmi2 )
+         CALL mpp_maxloc( e1t(:,:), tmask_1(:,:), ze1max, iima1,ijma1 )
+         CALL mpp_maxloc( e2t(:,:), tmask_1(:,:), ze2max, iima2,ijma2 )
+#else
          CALL mpp_minloc( e1t(:,:), tmask(:,:,1), ze1min, iimi1,ijmi1 )
          CALL mpp_minloc( e2t(:,:), tmask(:,:,1), ze2min, iimi2,ijmi2 )
          CALL mpp_maxloc( e1t(:,:), tmask(:,:,1), ze1max, iima1,ijma1 )
          CALL mpp_maxloc( e2t(:,:), tmask(:,:,1), ze2max, iima2,ijma2 )
+#endif
       ELSE
          ze1min = MINVAL( e1t(:,:), mask = tmask(:,:,1) == 1.e0 )    
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domcfg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domcfg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domcfg.F90	(revision 3211)
@@ -20,4 +20,7 @@
 
    PUBLIC   dom_cfg    ! called by opa.F90
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domhgr.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 3211)
@@ -32,4 +32,7 @@
 
    PUBLIC   dom_hgr   ! called by domain.F90
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 3211)
@@ -42,4 +42,9 @@
    INTEGER, ALLOCATABLE, SAVE, DIMENSION(:,:) ::  icoord ! Workspace for dom_msk_nsa()
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
@@ -165,7 +170,13 @@
       !
       tmask(:,:,:) = 0._wp
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpk
+#else
       DO jk = 1, jpk
          DO jj = 1, jpj
             DO ji = 1, jpi
+#endif
                IF( REAL( mbathy(ji,jj) - jk, wp ) + 0.1_wp >= 0._wp )   tmask(ji,jj,jk) = 1._wp
             END DO  
@@ -226,4 +237,20 @@
       ! 2. Ocean/land mask at u-,  v-, and z-points (computed from tmask)
       ! -------------------------------------------
+#ifdef key_z_first
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+            DO jk = 1, jpk
+               umask(ji,jj,jk) = tmask(ji,jj  ,jk) * tmask(ji+1,jj  ,jk)
+               vmask(ji,jj,jk) = tmask(ji,jj  ,jk) * tmask(ji  ,jj+1,jk)
+            END DO
+         END DO
+         DO ji = 1, jpim1         ! NO vector opt.
+            DO jk = 1, jpk
+               fmask(ji,jj,jk) = tmask(ji,jj  ,jk) * tmask(ji+1,jj  ,jk)   &
+                  &            * tmask(ji,jj+1,jk) * tmask(ji+1,jj+1,jk)
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 1, jpk
          DO jj = 1, jpjm1
@@ -238,4 +265,5 @@
          END DO
       END DO
+#endif
       CALL lbc_lnk( umask, 'U', 1._wp )      ! Lateral boundary conditions
       CALL lbc_lnk( vmask, 'V', 1._wp )
@@ -390,4 +418,11 @@
       CALL lbc_lnk( fmask, 'F', 1._wp )      ! Lateral boundary conditions on fmask
 
+#if defined key_z_first
+      !! 2d masks defined at sea surface only sometimes help performance
+      tmask_1(:,:) = tmask(:,:,1)
+      umask_1(:,:) = umask(:,:,1)
+      vmask_1(:,:) = vmask(:,:,1)
+      fmask_1(:,:) = fmask(:,:,1)
+#endif
             
       IF( nprint == 1 .AND. lwp ) THEN      ! Control print
@@ -491,7 +526,13 @@
       ! convex corners
       
+#if defined key_z_first
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1
          DO jj = 1, jpjm1
             DO ji = 1, jpim1
+#endif
                zaa = tmask(ji  ,jj,jk) + tmask(ji  ,jj+1,jk)   &
                   &+ tmask(ji+1,jj,jk) + tmask(ji+1,jj+1,jk)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90	(revision 3211)
@@ -17,4 +17,7 @@
 
    PUBLIC   dom_ngb   ! routine called in iom.F90 module
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -49,8 +52,15 @@
       zmask(:,:) = 0._wp
       SELECT CASE( cdgrid )
+#if defined key_z_first
+      CASE( 'U' )  ; zglam(:,:) = glamu(:,:) ; zgphi(:,:) = gphiu(:,:) ; zmask(nldi:nlei,nldj:nlej) = umask_1(nldi:nlei,nldj:nlej)
+      CASE( 'V' )  ; zglam(:,:) = glamv(:,:) ; zgphi(:,:) = gphiv(:,:) ; zmask(nldi:nlei,nldj:nlej) = vmask_1(nldi:nlei,nldj:nlej)
+      CASE( 'F' )  ; zglam(:,:) = glamf(:,:) ; zgphi(:,:) = gphif(:,:) ; zmask(nldi:nlei,nldj:nlej) = fmask_1(nldi:nlei,nldj:nlej)
+      CASE DEFAULT ; zglam(:,:) = glamt(:,:) ; zgphi(:,:) = gphit(:,:) ; zmask(nldi:nlei,nldj:nlej) = tmask_1(nldi:nlei,nldj:nlej)
+#else
       CASE( 'U' )  ; zglam(:,:) = glamu(:,:) ; zgphi(:,:) = gphiu(:,:) ; zmask(nldi:nlei,nldj:nlej) = umask(nldi:nlei,nldj:nlej,1)
       CASE( 'V' )  ; zglam(:,:) = glamv(:,:) ; zgphi(:,:) = gphiv(:,:) ; zmask(nldi:nlei,nldj:nlej) = vmask(nldi:nlei,nldj:nlej,1)
       CASE( 'F' )  ; zglam(:,:) = glamf(:,:) ; zgphi(:,:) = gphif(:,:) ; zmask(nldi:nlei,nldj:nlej) = fmask(nldi:nlei,nldj:nlej,1)
       CASE DEFAULT ; zglam(:,:) = glamt(:,:) ; zgphi(:,:) = gphit(:,:) ; zmask(nldi:nlei,nldj:nlej) = tmask(nldi:nlei,nldj:nlej,1)
+#endif
       END SELECT
 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domstp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domstp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domstp.F90	(revision 3211)
@@ -21,4 +21,8 @@
 
    PUBLIC   dom_stp   ! routine called by inidom.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 3211)
@@ -32,4 +32,10 @@
    REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:)     ::   r2dt   ! vertical profile time-step, = 2 rdttra 
       !                                                              ! except at nit000 (=rdttra) if neuler=0
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
 
    !! * Substitutions
@@ -110,4 +116,12 @@
       END DO  
       !                                         ! Compute and mask the inverse of the local depth at T, U, V and F points
+#if defined key_z_first
+      ee_t(:,:) = 1. / ee_t(:,:) * tmask_1(:,:)
+      ee_u(:,:) = 1. / ee_u(:,:) * umask_1(:,:)
+      ee_v(:,:) = 1. / ee_v(:,:) * vmask_1(:,:)
+      DO jj = 1, jpjm1                               ! f-point case fmask cannot be used 
+         ee_f(:,jj) = 1. / ee_f(:,jj) * umask_1(:,jj) * umask_1(:,jj+1)
+      END DO
+#else
       ee_t(:,:) = 1. / ee_t(:,:) * tmask(:,:,1)
       ee_u(:,:) = 1. / ee_u(:,:) * umask(:,:,1)
@@ -116,4 +130,5 @@
          ee_f(:,jj) = 1. / ee_f(:,jj) * umask(:,jj,1) * umask(:,jj+1,1)
       END DO
+#endif
       CALL lbc_lnk( ee_f, 'F', 1. )                  ! lateral boundary condition on ee_f
       !
@@ -172,7 +187,13 @@
                                                 ! initialise before scale factors at (u/v)-points
       ! Scale factor anomaly at (u/v)-points: surface averaging of scale factor at t-points
+#if defined key_z_first
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1
          DO jj = 1, jpjm1
             DO ji = 1, jpim1
+#endif
                zv_t_ij           = zs_t(ji  ,jj  ) * fse3t_b(ji  ,jj  ,jk)
                zv_t_ip1j         = zs_t(ji+1,jj  ) * fse3t_b(ji+1,jj  ,jk)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl_ftrans.h90	(revision 3211)
@@ -0,0 +1,24 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  domvvl_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   domvvl.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+
+!FTRANS mut :I :I :z
+!FTRANS muu :I :I :z
+!FTRANS muv :I :I :z
+!FTRANS muf :I :I :z
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 3211)
@@ -26,4 +26,7 @@
    PUBLIC dom_wri        ! routine called by inidom.F90
 
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
@@ -66,4 +69,9 @@
       USE wrk_nemo, ONLY:   zprt  => wrk_2d_1 , zprw  => wrk_2d_2    ! 2D workspace
       USE wrk_nemo, ONLY:   zdepu => wrk_3d_1 , zdepv => wrk_3d_2    ! 3D     -
+
+      !! DCSE_NEMO: wrk_3d_1, wrk_3d_2 are re-named, need additional directives
+!FTRANS zdepu :I :I :z
+!FTRANS zdepv :I :I :z
+
       !!
       INTEGER           ::   inum0    ! temprary units for 'mesh_mask.nc' file
@@ -129,14 +137,30 @@
       
       CALL dom_uniq( zprw, 'T' )
+#if defined key_z_first
+      zprt = tmask_1(:,:) * zprw                               !    ! unique point mask
+#else
       zprt = tmask(:,:,1) * zprw                               !    ! unique point mask
+#endif
       CALL iom_rstput( 0, 0, inum2, 'tmaskutil', zprt, ktype = jp_i1 )  
       CALL dom_uniq( zprw, 'U' )
+#if defined key_z_first
+      zprt = umask_1(:,:) * zprw
+#else
       zprt = umask(:,:,1) * zprw
+#endif
       CALL iom_rstput( 0, 0, inum2, 'umaskutil', zprt, ktype = jp_i1 )  
       CALL dom_uniq( zprw, 'V' )
+#if defined key_z_first
+      zprt = vmask_1(:,:) * zprw
+#else
       zprt = vmask(:,:,1) * zprw
+#endif
       CALL iom_rstput( 0, 0, inum2, 'vmaskutil', zprt, ktype = jp_i1 )  
       CALL dom_uniq( zprw, 'F' )
+#if defined key_z_first
+      zprt = fmask_1(:,:) * zprw
+#else
       zprt = fmask(:,:,1) * zprw
+#endif
       CALL iom_rstput( 0, 0, inum2, 'fmaskutil', zprt, ktype = jp_i1 )  
 
@@ -165,5 +189,9 @@
       
       ! note that mbkt is set to 1 over land ==> use surface tmask
+#if defined key_z_first
+      zprt(:,:) = tmask_1(:,:) * REAL( mbkt(:,:) , wp )
+#else
       zprt(:,:) = tmask(:,:,1) * REAL( mbkt(:,:) , wp )
+#endif
       CALL iom_rstput( 0, 0, inum4, 'mbathy', zprt, ktype = jp_i2 )     !    ! nb of ocean T-points
             
@@ -209,7 +237,13 @@
          IF( nmsh <= 3 ) THEN                                   !    ! 3D depth
             CALL iom_rstput( 0, 0, inum4, 'gdept', gdept, ktype = jp_r4 )     
-            DO jk = 1,jpk   
+#if defined key_z_first
+            DO jj = 1, jpjm1   
+               DO ji = 1, jpim1         ! NO vector opt.
+                  DO jk = 1, jpk   
+#else
+            DO jk = 1, jpk   
                DO jj = 1, jpjm1   
                   DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                      zdepu(ji,jj,jk) = MIN( gdept(ji,jj,jk) , gdept(ji+1,jj  ,jk) )
                      zdepv(ji,jj,jk) = MIN( gdept(ji,jj,jk) , gdept(ji  ,jj+1,jk) )
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 3211)
@@ -55,4 +55,8 @@
    REAL(wp) ::   rn_hc       =  150._wp     ! Critical depth for s-sigma coordinates
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+
   !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -78,5 +82,5 @@
       !!                   ln_zco=T   z-coordinate   
       !!                   ln_zps=T   z-coordinate with partial steps
-      !!                   ln_zco=T   s-coordinate 
+      !!                   ln_sco=T   s-coordinate 
       !!
       !! ** Action  :   define gdep., e3., mbathy and bathy
@@ -758,7 +762,27 @@
       !! ** Method  :   set 3D coord. arrays to reference 1D array 
       !!----------------------------------------------------------------------
+#if defined key_z_first
+      INTEGER  ::   ji, jj   ! Dummy loop indices
+#else
       INTEGER  ::   jk
-      !!----------------------------------------------------------------------
-      !
+#endif
+      !!----------------------------------------------------------------------
+      !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            fsdept(ji,jj,:) = gdept_0(:)
+            fsdepw(ji,jj,:) = gdepw_0(:)
+            fsde3w(ji,jj,:) = gdepw_0(:)
+            fse3t (ji,jj,:) = e3t_0(:)
+            fse3u (ji,jj,:) = e3t_0(:)
+            fse3v (ji,jj,:) = e3t_0(:)
+            fse3f (ji,jj,:) = e3t_0(:)
+            fse3w (ji,jj,:) = e3w_0(:)
+            fse3uw(ji,jj,:) = e3w_0(:)
+            fse3vw(ji,jj,:) = e3w_0(:)
+         END DO
+      END DO
+#else
       DO jk = 1, jpk
          fsdept(:,:,jk) = gdept_0(jk)
@@ -773,4 +797,5 @@
          fse3vw(:,:,jk) = e3w_0(jk)
       END DO
+#endif
       !
    END SUBROUTINE zgr_zco
@@ -824,4 +849,6 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zprt => wrk_3d_1
+      !! DCSE_NEMO: wrk_3d_1 renamed, need additional directive
+!FTRANS zprt :I :I :z
       !!
       INTEGER  ::   ji, jj, jk       ! dummy loop indices
@@ -871,4 +898,14 @@
 
       ! Scale factors and depth at T- and W-points
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi                     ! intitialization to the reference z-coordinate
+            gdept(ji,jj,:) = gdept_0(:)
+            gdepw(ji,jj,:) = gdepw_0(:)
+            e3t  (ji,jj,:) = e3t_0  (:)
+            e3w  (ji,jj,:) = e3w_0  (:)
+         END DO
+      END DO
+#else
       DO jk = 1, jpk                        ! intitialization to the reference z-coordinate
          gdept(:,:,jk) = gdept_0(jk)
@@ -877,4 +914,5 @@
          e3w  (:,:,jk) = e3w_0  (jk)
       END DO
+#endif
       ! 
       DO jj = 1, jpj
@@ -938,4 +976,14 @@
 
       ! Scale factors and depth at U-, V-, UW and VW-points
+#if defined key_z_first
+      DO jj = 1, jpj                        ! initialisation to z-scale factors
+         DO ji = 1, jpi
+            e3u (ji,jj,:) = e3t_0(:)
+            e3v (ji,jj,:) = e3t_0(:)
+            e3uw(ji,jj,:) = e3w_0(:)
+            e3vw(ji,jj,:) = e3w_0(:)
+         END IF
+      END DO
+#else
       DO jk = 1, jpk                        ! initialisation to z-scale factors
          e3u (:,:,jk) = e3t_0(jk)
@@ -944,7 +992,14 @@
          e3vw(:,:,jk) = e3w_0(jk)
       END DO
-      DO jk = 1,jpk                         ! Computed as the minimum of neighbooring scale factors
+#endif
+#if defined key_z_first
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+            DO jk = 1, jpk        ! Computed as the minimum of neighbouring scale factors
+#else
+      DO jk = 1,jpk               ! Computed as the minimum of neighbouring scale factors
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                e3u (ji,jj,jk) = MIN( e3t(ji,jj,jk), e3t(ji+1,jj,jk) )
                e3v (ji,jj,jk) = MIN( e3t(ji,jj,jk), e3t(ji,jj+1,jk) )
@@ -965,4 +1020,18 @@
       
       ! Scale factor at F-point
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi                     ! initialisation to z-scale factors
+            e3f(ji,jj,:) = e3t_0(:)
+         END DO
+      END DO
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1                   ! NO vector opt.
+            DO jk = 1, jpk                  ! Computed as the minimum of neighbooring V-scale factors
+               e3f(ji,jj,jk) = MIN( e3v(ji,jj,jk), e3v(ji+1,jj,jk) )
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 1, jpk                        ! initialisation to z-scale factors
          e3f(:,:,jk) = e3t_0(jk)
@@ -975,4 +1044,5 @@
          END DO
       END DO
+#endif
       CALL lbc_lnk( e3f, 'F', 1._wp )       ! Lateral boundary conditions
       !
@@ -1129,4 +1199,15 @@
       USE wrk_nemo, ONLY:   esigwu3 => wrk_3d_9
       USE wrk_nemo, ONLY:   esigwv3 => wrk_3d_10
+      !! DCSE_NEMO: wrk_nemo module variables renamed, need additional directives
+!FTRANS gsigw3 :I :I :z
+!FTRANS gsigt3 :I :I :z
+!FTRANS gsi3w3 :I :I :z
+!FTRANS esigt3 :I :I :z
+!FTRANS esigw3 :I :I :z
+!FTRANS esigtu3 :I :I :z
+!FTRANS esigtv3 :I :I :z
+!FTRANS esigtf3 :I :I :z
+!FTRANS esigwu3 :I :I :z
+!FTRANS esigwv3 :I :I :z
       !
       INTEGER  ::   ji, jj, jk, jl           ! dummy loop argument
@@ -1574,7 +1655,13 @@
 
 !!gm bug?  no more necessary?  if ! defined key_helsinki
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpk
+#else
       DO jk = 1, jpk
          DO jj = 1, jpj
             DO ji = 1, jpi
+#endif
                IF( fse3w(ji,jj,jk) <= 0._wp .OR. fse3t(ji,jj,jk) <= 0._wp ) THEN
                   WRITE(ctmp1,*) 'zgr_sco :   e3w   or e3t   =< 0  at point (i,j,k)= ', ji, jj, jk
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DOM/istate.F90	(revision 3211)
@@ -50,4 +50,13 @@
    PUBLIC   istate_init   ! routine called by step.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "dtatem_ftrans.h90"
+#  include "dtasal_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -67,5 +76,5 @@
       !!----------------------------------------------------------------------
       ! - ML - needed for initialization of e3t_b
-      INTEGER  ::  jk     ! dummy loop indice
+      INTEGER  ::  ji, jj, jk     ! dummy loop indices
 
       IF(lwp) WRITE(numout,*)
@@ -134,7 +143,11 @@
          ! - ML - sshn could be modified by istate_eel, so that initialization of fse3t_b is done here
          IF( lk_vvl ) THEN
+#if defined key_z_first
+            fse3t_b(:,:,:) = fse3t_n(:,:,:)
+#else
             DO jk = 1, jpk
                fse3t_b(:,:,jk) = fse3t_n(:,:,jk)
             ENDDO
+#endif
          ENDIF
          ! 
@@ -169,7 +182,13 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
       !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpk
+#else
       DO jk = 1, jpk
          DO jj = 1, jpj
             DO ji = 1, jpi
+#endif
                tn(ji,jj,jk) = (  ( ( 7.5 - 0.*ABS(gphit(ji,jj))/30. )   &
                   &               *( 1.-TANH((fsdept(ji,jj,jk)-80.)/30.) )   &
@@ -253,8 +272,19 @@
             zcst   = ( zt1 * ( zh1 - zh2) - ( zt1 - zt2 ) * zh1 ) / ( zh1 - zh2 )
             !
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  DO jk = 1, jpk
+                     tn(ji,jj,jk) = ( zt2 + zt1 * exp( - fsdept(ji,jj,jk) / 1000 ) ) * tmask(ji,jj,jk)
+                     tb(ji,jj,jk) = tn(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
+#else
             DO jk = 1, jpk
                tn(:,:,jk) = ( zt2 + zt1 * exp( - fsdept(:,:,jk) / 1000 ) ) * tmask(:,:,jk)
                tb(:,:,jk) = tn(:,:,jk)
             END DO
+#endif
             !
             IF(lwp) CALL prizre( tn    , jpi   , jpj   , jpk   , jpj/2 ,   &
@@ -294,5 +324,9 @@
             DO jj = 1, nlcj
                DO ji = 1, nlci
+#if defined key_z_first
+                  sshb(ji,jj) = zssh( mig(ji) , mjg(jj) ) * tmask_1(ji,jj)
+#else
                   sshb(ji,jj) = zssh( mig(ji) , mjg(jj) ) * tmask(ji,jj,1)
+#endif
                END DO
             END DO
@@ -374,7 +408,13 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
 
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpk
+#else
          DO jk = 1, jpk
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   tn(ji,jj,jk) = (  16. - 12. * TANH( (fsdept(ji,jj,jk) - 400) / 700 )         )   &
                        &           * (-TANH( (500-fsdept(ji,jj,jk)) / 150 ) + 1) / 2               &
@@ -448,4 +488,6 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zprn => wrk_3d_1    ! 3D workspace
+      !! DCSE_NEMO: wrk_3d_1 renamed, need additional directive
+!FTRANS zprn :I :I :z
 
       USE dynspg          ! surface pressure gradient             (dyn_spg routine)
@@ -473,14 +515,31 @@
       zprn(:,:,1) = zalfg * fse3w(:,:,1) * ( 1 + rhd(:,:,1) )       ! Surface value
 
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 2, jpkm1                                        ! Vertical integration from the surface
+               zprn(ji,jj,jk) = zprn(ji,jj,jk-1)   &
+                  &           + zalfg * fse3w(ji,jj,jk) * ( 2. + rhd(ji,jj,jk) + rhd(ji,jj,jk-1) )
+            END DO  
+         END DO  
+      END DO  
+#else
       DO jk = 2, jpkm1                                              ! Vertical integration from the surface
          zprn(:,:,jk) = zprn(:,:,jk-1)   &
             &         + zalfg * fse3w(:,:,jk) * ( 2. + rhd(:,:,jk) + rhd(:,:,jk-1) )
       END DO  
+#endif
 
       ! Compute geostrophic balance
       ! ---------------------------
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vertor opt.
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zmsv = 1. / MAX(  umask(ji-1,jj+1,jk) + umask(ji  ,jj+1,jk)   &
                                + umask(ji-1,jj  ,jk) + umask(ji  ,jj  ,jk) , 1.  )
@@ -511,8 +570,19 @@
       ! to have a zero bottom velocity
 
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+               un(ji,jj,jk) = ( un(ji,jj,jk) - un(ji,jj,jpkm1) ) * umask(ji,jj,jk)
+               vn(ji,jj,jk) = ( vn(ji,jj,jk) - vn(ji,jj,jpkm1) ) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 1, jpkm1
          un(:,:,jk) = ( un(:,:,jk) - un(:,:,jpkm1) ) * umask(:,:,jk)
          vn(:,:,jk) = ( vn(:,:,jk) - vn(:,:,jpkm1) ) * vmask(:,:,jk)
       END DO
+#endif
 
       CALL lbc_lnk( un, 'U', -1. )
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtasal.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtasal.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtasal.F90	(revision 3211)
@@ -32,4 +32,9 @@
 
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_sal   ! structure of input SST (file informations, fields read)
+
+   !! * Control permutation of array indices
+#  include "dtasal_ftrans.h90"
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
@@ -158,8 +163,19 @@
 #endif   
         
-      s_dta(:,:,:)=sf_sal(1)%fnow(:,:,:)
+#if defined key_z_first
+      !! DCSE_NEMO: Beware! These arrays will not be conformable after permuting indices of t_dta
+      DO jk = 1, jpk
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               s_dta(ji,jj,jk) = sf_sal(1)%fnow(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+#else
+      s_dta(:,:,:) = sf_sal(1)%fnow(:,:,:)
+#endif
         
       IF( ln_sco ) THEN
-         DO jj = 1, jpj                  ! interpolation of salinites
+         DO jj = 1, jpj                  ! interpolation of salinities
             DO ji = 1, jpi
                DO jk = 1, jpk
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtasal_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtasal_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtasal_ftrans.h90	(revision 3211)
@@ -0,0 +1,21 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  dtasal_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   dtasal.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+!FTRANS s_dta :I :I :z
+
